clear all;
close all;

p = 0.01;
a = 0.5;
power = [];
outlier = [];

fcperiod = [252 500 1000 1500 2500];
nsim = 10000;

[MCS_CC_CV] = xlsread('MCS_CC_CV');

[q_252]=xlsread('Mean_252');
[q_500]=xlsread('Mean_500');
[q_1000]=xlsread('Mean_1000');
[q_1500]=xlsread('Mean_1500');
[q_2500]=xlsread('Mean_2500');

for x = 1:6
    d=p*((x-1)/10);
    for y = 1:5
        if y==1
            padj = p;
        elseif y==2
            padj = p*1.1;
        elseif y==3
            padj = p*1.25;
        elseif y==4
            padj = p*1.5;    
        elseif y==5
            padj = p*2.0;
        end

        test = zeros(1,length(fcperiod));
        dursqsum = NaN(nsim,length(fcperiod));
        viosum = NaN(nsim,length(fcperiod));
        viomean = NaN(nsim,length(fcperiod));
        outlierz = zeros(length(fcperiod),1);

        for j = 1:length(fcperiod)
            if j == 1
                qm = q_252;
            elseif j == 2
                qm = q_500;
            elseif j == 3
                qm = q_1000;
            elseif j == 4
                qm = q_1500;
            elseif j == 5
                qm = q_2500;
            end

            if p==0.01
                CV_CC = MCS_CC_CV((find(MCS_CC_CV(:,1)==a)+j-1),(2:4));
            elseif p==0.05
                CV_CC = MCS_CC_CV((find(MCS_CC_CV(:,5)==a)+j-1),(6:8));
            end    

            while test(1,j)<nsim                

                n1= ceil(fcperiod(j)/4);
                n2= ceil(fcperiod(j)/4);
                n3= floor(fcperiod(j)/4);
                n4 = fcperiod(j) - sum([n1 n2 n3]);
                viovec=[binornd(1,padj-2*d,1,n1) binornd(1,padj+d,1,n2) binornd(1,padj-d,1,n3) binornd(1,padj+2*d,1,n4)];

                if sum(viovec)<1
                    outlierz(j,1) = outlierz(j,1) + 1;
                elseif sum(viovec)>1
                    test(1,j) = test(1,j) + 1;
                    viosum(test(1,j),j) = sum(viovec)+normrnd(0,0.001,1);
                    viomean(test(1,j),j) = abs(((viosum(test(1,j),j))/fcperiod(j)-p))/p;
     
                    q = qm(find(qm(:,1)==sum(viovec)),2);
                    if length(q)<1
                        outlierz(j,1) = outlierz(j,1) + 1;
                    else
                        durres = Duree(viovec);
                        dur = durres.duree;
                        dursqsum(test(1,j),j) = sum(dur.^2)+normrnd(0,0.001,1);

                        if dursqsum(test(1,j),j) >= q                
                            durmean(test(1,j),j) = (dursqsum(test(1,j),j)-q)/q;
                        else 
                            durmean(test(1,j),j) = 0;
                        end
                        res_CC(test(1,j),j) = a*viomean(test(1,j),j)+(1-a)*durmean(test(1,j),j);
                    end
                end                

                [x y j test(1,j)]
            end
            rej01(j,1) = sum(res_CC(:,j)>=CV_CC(1));
            rej05(j,1) = sum(res_CC(:,j)>=CV_CC(2));
            rej10(j,1) = sum(res_CC(:,j)>=CV_CC(3));

            power01(j,1) = [rej01(j)/test(1,j)];
            power05(j,1) = [rej05(j)/test(1,j)];
            power10(j,1) = [rej10(j)/test(1,j)];
        end    
        power = [power
          0 0 0
          power01 power05 power10];
      
        outlier = [outlier
                    0
                    outlierz];
    end
end
[power outlier]
