clear all
close all

format long

p = 0.01;
x=3;
y=2;

d=p*(x/10);
pfac=[1.1 1.25 1.5 2.0];
padj = p*pfac(y);


powerz = [];
power = [];
fcperiod = [252 500 1000 1500 2500];
nsim = 10000;

[MCS_CC_CV] = xlsread('MCS_CC_CV');

[q_252]=xlsread('Mean_252');
[q_500]=xlsread('Mean_500');
[q_1000]=xlsread('Mean_1000');
[q_1500]=xlsread('Mean_1500');
[q_2500]=xlsread('Mean_2500');


for z = 1:11
    a = (z-1)/10;
    
    dursqsum = zeros(nsim,1);
    viosum = zeros(nsim,1);
    viomean = zeros(nsim,1);
    
    for j = 3%1:5
        if j == 1
            qm = q_252;
        elseif j == 2
            qm = q_500;
        elseif j == 3
            qm = q_1000;
        elseif j == 4
            qm = q_1500;
        elseif j == 5
            qm = q_2500;
        end  

        if p==0.01
            CV_CC = MCS_CC_CV((find(MCS_CC_CV(:,1)==a)+j-1),(2:4));
        elseif p==0.05
            CV_CC = MCS_CC_CV((find(MCS_CC_CV(:,5)==a)+j-1),(6:8));
        end 
        
        test = 0;

        while test<nsim           

            n1= ceil(fcperiod(j)/4);
            n2= ceil(fcperiod(j)/4);
            n3= floor(fcperiod(j)/4);
            n4 = fcperiod(j) - sum([n1 n2 n3]);
            viovec=[binornd(1,padj-2*d,1,n1) binornd(1,padj+d,1,n2) binornd(1,padj-d,1,n3) binornd(1,padj+2*d,1,n4)];
            
            if sum(viovec)>1
                test = test + 1;

                viosum(test,j) = sum(viovec)+normrnd(0,0.001,1);
                viomean(test,j) = abs(((viosum(test,j))/fcperiod(j)-p)/p);
           
                q = qm(find(qm(:,1)==sum(viovec)),2);            
                durres = Duree(viovec);
                dur = durres.duree;
                dursqsum(test,j) = sum(dur.^2)+normrnd(0,0.001,1);

                if dursqsum(test,j) >= q                
                    durmean(test,j) = (dursqsum(test,j)-q)/q;
                else 
                    durmean(test,j) = 0;
                end
                res_CC(test,j) = a*viomean(test,j)+(1-a)*durmean(test,j);
            end            

            [z j test]
        end
        rej01 = sum(res_CC(:,j)>=CV_CC(1));
        rej05 = sum(res_CC(:,j)>=CV_CC(2));
        rej10 = sum(res_CC(:,j)>=CV_CC(3));

        power01(j,1) = [rej01/test];
        power05(j,1) = [rej05/test];
        power10(j,1) = [rej10/test];
    end 
    powerz = [power01 power05 power10]
    power = [power
             powerz];
end
power

         

